#include "ti86.inc"
#define function(mod) .module mod\mod

.org _asm_exec_ram

function(header):
	nop
	jp	@start
	.dw	0
	.dw	@title + 1

@title	.db	" OnPar by Kirk Meyer  ",0

@start	call	_clrscrn
	call	_homeup
	set	textinverse,[iy + textflags]
	ld	hl,@title
	call	_puts
	ld	hl,$5a69
	rst	20h
	rst	10h
	jr	nc,@undo
	ld	hl,code@end - code@start
	call	_createprog
	call	_data_size_to_de
	call	_set_abs_dest_addr
	xor	a
	ld	hl,code
	call	_set_abs_src_addr
	ex	de,hl
	call	_mm_ldir_set_size
	set	4,[iy + $24]
	ld	hl,@is
@done	call	_puts
	ld	hl,@inst
	res	doneprgm,[iy + doneflags]
	call	_puts	
	res	textinverse,[iy + textflags]
	jp	_newline
	
@undo	res	4,[iy+$24]
	call	_delvar
	ld	hl,@not
	jr	@done

@inst	.db "installed. ",0
@not	.db "is now un",0
@is	.db "has been ",0

function(code):
	.org	_asm_exec_ram - 2

@start	.db	$8e,$28
	call	_runindicoff
	ld	bc,[_asm_reg_bc]
	push	bc
	ld	hl,[_currow]
	push	hl
	ld	hl,-($0100 + lrparen)
	adc	hl,bc
	jr	nz,@cont
	ld	a,[_p_editcursor]
	ld	hl,[_p_editcursor + 1]
	ld	de,[_p_edittop + 1]
	ld	bc,[_p_edittop - 1]
	ld	c,1
@loop	call	_dec_ptr_ahl
	call	_ahl_cmp_bde
	jr	c,@break
	push	af
	push	hl
	call	_getb_ahl	
	cp	')'
	jr	nz,@nl
	inc	c
@nl	cp	'('
	jr	nz,@nr
	dec	c
	jr	nz,@nr
	ld	de,$FFFF
	ld	b,d
@nr	ld	hl,_curcol
	ld	a,[hl]
	dec	[hl]
	or	a
	jr	nz,@mod
	ld	[hl],20
	dec	hl
	dec	[hl]
	jp	p,@mod
	ld	[hl],$FF
@mod	ld	a,c
	or	a
	pop	hl
	pop	af
	jr	@loop
@break	ld	a,c
	or	a
	jr	nz,@fin
	set	textinverse,[iy + textflags]
	ld	hl,[_currow]
	ld	a,l
	cp	8
	jr	nc,@nod1
	ld	a,'('
	call	_putmap
@nod1	ex	[sp],hl
	ld	[_currow],hl
	ld	a,')'
	call	_putmap
	ld	b,64
@wait	halt
	djnz	@wait
	res	textinverse,[iy + textflags]
	ld	hl,[_currow]
	ex	[sp],hl
	ld	[_currow],hl
	ld	a,l
	cp	8
	jr	nc,@cont
	ld	a,'('
	call	_putmap
@cont	ld	a,[_asm_reg_a]
	cp	a
@fin	pop	hl
	ld	[_currow],hl
	pop	bc
	ret
@end

.end
